#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

typedef struct {
    int sirka, vyska;
    int ** data;
} matice;

typedef struct {
    int pocet;
    matice ** data;
} vyraz;

void mat_init (matice * x, int vyska, int sirka) {
    *x = (matice){sirka, vyska, malloc(vyska * sizeof(int *))};
    for (int i = 0; i < vyska; i++) {
        x->data[i] = malloc(sirka*sizeof(int));
    }
}

void mat_free (matice x) {
    for (int i = 0; i < x.vyska; i++) {
        free(x.data[i]);
    }
    free(x.data);
}

void mat_fill (matice x, int k) {
    for(int i = 0; i < x.vyska; i++) {
        for (int j = 0; j < x.sirka; j++) {
            x.data[i][j] = k;
        }
    }
}

void mat_print (matice * x) {
    for(int i = 0; i < x->vyska; i++) {
        for (int j = 0; j < x->sirka; j++) {
            printf("%2i ", x->data[i][j]);
        }
        printf("\n");
    }
}

void exp_init (vyraz * x) {
    x->pocet = 0;
    x->data = malloc(sizeof(matice *));
}

void exp_free (vyraz x) {
    free (x.data);
}

void set (matice x, int a, int b, int value) {
    assert(a < x.vyska || b < x.sirka);
    x.data[a][b] = value;
}

int get (matice * x, int a, int b) {
    assert(a < x->vyska || b < x->sirka);
    return x->data[a][b];
}

void add (vyraz * x, matice * a) {
    x->data[x->pocet++] = a;
    x->data = realloc(x->data, (x->pocet + 1) * sizeof(matice *));
}

int main()
{
    matice A, B;
    vyraz V;

    exp_init(&V);

    mat_init (&A, 5, 5);
    mat_fill (A, 1);
    mat_init (&B, 5, 5);
    mat_fill (B, 3);
    // set (A, 13, 13, 10);
    // printf("%i", get(A, 3, 3));

    add (&V, &A);
    add (&V, &B);
    // prvek A[3,3]
    printf("A[3,3] = %i\n", get(V.data[0], 3, 3));
    // prvek B[3,3]
    printf("B[3,3] = %i\n", get(V.data[1], 3, 3));

    // prohozeni matic A a V ve vyrazu V
    matice * tmp = V.data[0];
    V.data[0] = V.data[1];
    V.data[1] = tmp;

    mat_print (V.data[0]);
    mat_print (V.data[1]);

    mat_free (A);
    mat_free (B);
    exp_free (V);

    return 0;
}