#include <stdio.h>
#include <stdlib.h>

typedef struct u {
    int data; 
    struct u * ukazatel;
} uzel;

void seznam_tisk (uzel * x) {
    if (x->ukazatel == NULL) {
        printf("%i\n", x->data);
        return;
    }
    printf("%i\n", x->data);
    seznam_tisk (x->ukazatel);
}

void seznam_pridat (uzel * x, int data) {
    // najdu konec seznamu
    while (x->ukazatel != NULL) x = x->ukazatel;
    // vytvorim novy uzel
    uzel * t = malloc(sizeof(uzel));
    t->data = data;
    t->ukazatel = NULL;
    x->ukazatel = t;
}

/* 
    novy kod
    na prednasce pouze zminena
    * nutnost uvolneni
    * technika vkladani pro vytvoreni serazeneho seznamu 
*/

void seznam_uvolnit (uzel * x)
{
    while (1) {
        // poznamenam si, kam odkazuje x->ukazatel
        uzel * tmp = x->ukazatel;
        // dealokuji uzel
        free (x);
        // nastavim aktualni uzel na dalsi v poradi
        x = tmp;
        if (x->ukazatel == NULL) 
        {
            free(x);
            break;
        }
    }
}

void seznam_vlozit (uzel * x, int data) {
    while (x->ukazatel != NULL) {
        // prochazim seznam tak dlouho, dokud nenajdu 
        // takove dva uzly, pro ktere plati podminka
        // pozn: po sobe jdouci uzly: x->data, x->ukazatel->data
        if (x->data < data && data < x->ukazatel->data) {
            uzel * t = malloc(sizeof(uzel));
            t->data = data;
            t->ukazatel = x->ukazatel;
            x->ukazatel = t;
            return;
        }
        x = x->ukazatel;
    }
    // pokud dosel program az sem, jsem na konci seznamu
    // nepodarilo se najit vhodne misto, nebo prvek uz v seznamu byl
    // pokud je vkladany prvek vetsi nez posledni prvek seznamu, 
    // tak ho pridam na konec
    if (data > x->data)
        seznam_pridat (x, data);
}

int main ()
{
    uzel * a = malloc (sizeof(uzel));
    // inicializace uzlu, ktery je vstupnim bodem seznamu
    a->data = 10;
    a->ukazatel = NULL;

    seznam_pridat (a, 20);
    seznam_pridat (a, 30);
    seznam_pridat (a, 40);
    seznam_vlozit (a, 25);
    seznam_vlozit (a, 50);

    seznam_tisk (a);
    seznam_uvolnit (a);

    return 0;
}